=== debian/changelog ===
awesome (4.3-8ubuntu1) resolute; urgency=medium

  * Add Build-Depends: lua5.1 to work around Debian #1118655
  * Update autopkgtest to use lua5.3 since lua5.2 is no longer supported
    by the lua-lgi package

 -- Jeremy Bícha <jbicha@ubuntu.com>  Thu, 23 Oct 2025 11:48:48 -0400

awesome (4.3-8) unstable; urgency=medium

  [ Marco Trevisan (Treviño) ]
  * Use GioUnix to use Unix specific classes in Gio. (Closes: #1115591)

  [ Reiner Herrmann ]
  * Bump Standards-Version to 4.7.2.
  * Convert d/watch to version 5.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 18 Sep 2025 21:15:04 +0200

awesome (4.3-7) unstable; urgency=medium

  * Update Standards-Version to 4.6.2.
    - Recalculate wm alternative priority based on Policy.
  * Call dh_installwm only for awesome package.
  * Replace obsolete build and test dependencies:
    libxcb-util0-dev -> libxcb-util-dev.
  * Export XDG_CACHE_HOME during autopkgtest as fontconfig needs it to
    find writable cache directory.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 04 Feb 2023 23:46:48 +0100

awesome (4.3-6) unstable; urgency=medium

  * Build-depend on libgdk-pixbuf-2.0-dev instead of libgdk-pixbuf2.0-dev.
    (Closes: #1019306)
  * Bump Standards-Version to 4.6.1.
  * Bump copyright year.
  * Use api.github.com for searching upstream releases.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 02 Oct 2022 16:31:47 +0200

awesome (4.3-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/tests/control: Add restriction "allow-stderr". (Closes: #1017032)

 -- Marcos Talau <talau@debian.org>  Mon, 05 Sep 2022 13:10:29 -0300

awesome (4.3-5) unstable; urgency=medium

  * Fix FTBFS with GCC 10. (Closes: #957027)
  * Replace obsolete variable ADTTMP with AUTOPKGTEST_TMP in autopkgtest.
  * Bump Standards-Version to 4.5.0.
  * Bump debhelper compat level to 13.
  * Drop explicit nocheck test in dh_override_auto_test, as it is correctly
    skipped in dh compat 13.
  * Update Vcs-* URLs.

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 22 Jul 2020 11:58:50 +0200

awesome (4.3-4) unstable; urgency=low

  * Increase timeouts of test runs during autopkgtest.
    Tests are failing on Ubuntu autopkgtest infrastructure on really
    slow hardware. Timeouts are increased to values suggested by upstream.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 26 Feb 2019 18:51:19 +0100

awesome (4.3-3) unstable; urgency=medium

  * Add dependency on gir1.2-gdkpixbuf-2.0 for awesome. (Closes: #920841)
  * Add explicit dependency on gir1.2-glib-2.0 (which was only transitively
    depended on via gir1.2-freedesktop).
  * Recommend gir1.2-gtk-3.0 for gtk theme.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 29 Jan 2019 21:48:12 +0100

awesome (4.3-2) unstable; urgency=medium

  * Create required directories to fix arch:all-only builds.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 28 Jan 2019 22:54:50 +0100

awesome (4.3-1) unstable; urgency=medium

  * New upstream release.
    - handle SIGCHLD directly instead of through GLib (Closes: #886393)
  * Drop obsolete/applied patches and refresh remaining ones.
  * Build-depend on asciidoctor instead of asciidoc. (Closes: #894710)
  * Update Standards-Version to 4.3.0.
    - declare that debian/rules does not require root
  * Bump copyright years.
  * Install upstream release notes into /usr/share/doc/awesome/.
  * Build-depend on debhelper-compat and bump compat level to 12.
  * Update test dependencies.
  * Cherry-pick upstream patches to build example images reproducibly.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 28 Jan 2019 21:57:00 +0100

awesome (4.2-5) unstable; urgency=medium

  * Import upstream patch to fix performance issue with category icon lookup.
    (Closes: #893053)
    - add additional patch for looking up category icons in the correct path
  * Move packaging VCS to salsa.
  * Bump Standards-Version to 4.1.3.
  * Fix spelling in patches.
  * Add check for nocheck in override_dh_auto_test target.
  * Add upstream metadata file.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 17 Mar 2018 19:30:38 +0100
