=== debian/tests/control ===
Tests: integration.sh
Depends: awesome, lua5.3, xvfb, dbus-x11, xterm, xfonts-base, x11-apps, x11-xserver-utils, x11-utils, gir1.2-gtk-3.0, build-essential, libxcb1-dev, libxcb-util-dev, libxcb-icccm4-dev
Restrictions: allow-stderr
