=== debian/watch ===
Version: 5

Template: Github
Owner: awesomeWM
Project: awesome
